
/*
Mamel Alboury NDIAYE
Master1-IWOCS
2021-2022
*/

import java.util.*;

private static final int rectSize = 6;
Regles regles;
int[][] space;
int[][] nextSpace;
int[][] langtonLoop = {{0,2,2,2,2,2,2,2,2,0,0,0,0,0},
                       {2,1,7,0,1,4,0,1,4,2,0,0,0,0},
                       {2,0,2,2,2,2,2,2,0,2,0,0,0,0},
                       {2,7,2,0,0,0,0,2,1,2,0,0,0,0},
                       {2,1,2,0,0,0,0,2,1,2,0,0,0,0},
                       {2,0,2,0,0,0,0,2,1,2,0,0,0,0},
                       {2,7,2,0,0,0,0,2,1,2,0,0,0,0},
                       {2,1,2,2,2,2,2,2,1,2,2,2,2,2},
                       {2,0,7,1,0,7,1,0,7,1,1,1,1,1},
                       {0,2,2,2,2,2,2,2,2,2,2,2,2,2}};
                       
color[] colors = new color[]{
  color(  0,  0,  0), color(  0,  0,255), color(255,  0,  0), color(  0,255,  0),
  color(255,255,  0), color(255,  0,255), color(255,255,255), color(  0,255,255) };

void setup() {
  size(640, 480);

  regles = new Regles("langtonloop.txt");
  space = new int[width/rectSize][height/rectSize];
  initLangton();
   frameRate(20);
}

void initLangton() {
  int offsetX  = height/rectSize/2; 
  int offsetY = width/rectSize/2;
  for(int i = offsetX ; i < offsetX  + langtonLoop.length; i++) {
    for(int j = offsetY; j < offsetY + langtonLoop[0].length; j++) {
      space[j][i] = langtonLoop[i-offsetX ][j-offsetY];
    }
  }
}
//create the object
void createRect(int x, int y) {
  rect(x, y, rectSize, rectSize);
}

void draw() {
  background(255);
  // Draw state space
  for(int i = 0; i < space.length; i++) {
    for(int j = 0; j < space[0].length; j++) {
      fill(colors[space[i][j]]);
      createRect(i*rectSize, j*rectSize);
    }
  }
  
  
  //calculate the next state t+1
  nextSpace = new int[width/rectSize][height/rectSize];
  for(int i = 0; i < space.length; i++) {
    for(int j = 0; j < space[0].length; j++) {
      if(i != 0 && j != 0 && i != (width/rectSize)-1 && j != (height/rectSize)-1) {
        nextSpace[i][j] = regles.correspond(space[i][j], space[i][j-1], space[i+1][j], space[i][j+1], space[i-1][j]);
      }
    }
  }
 //copy nextSpace to space
 for(int i = 0; i < space.length; i++) {
    System.arraycopy(nextSpace[i], 0, space[i], 0, space[0].length);
  }

}
